!=====================================================================================
!    sheet.
!  , ., 2024.
!=====================================================================================

           MEMBER

    INCLUDE('fsSheet.INC')
    INCLUDE('POToolbar.inc')

     MAP
         MODULE('fslibs6.lib')
            FsDebugOut(string,<byte>)
         END
     END

!===================================================================================
!  
!
FsSheet.Init PROCEDURE  (pSheet, pImage, pClassToolbar, pClassGlob)
      CODE
   if SELF.Active=1
      return
   end
      
   if pSheet=0 or pImage<10000
      return
   .   
      
   if pSheet{PROP:Above}=0  ! 
      return
   .   
      
   if pSheet{PROP:Wizard}=1
      return
   .   
   if 0{PROP:Toolbox}=1
      return
   .         
      
   SELF.Active=1
   SELF.TabsStyle=1
   
   SELF.QueueTabs &= new(FsSheetQueueTabsType)
   SELF.ControlSheet  = pSheet  
   SELF.ControlImage  = pImage
   SELF.ControlString = pImage+1
   SELF.ControlSheetTB = pImage+2
   if SELF.ControlSheet{PROP:Parent}>0   
      create(SELF.ControlImage,CREATE:image,SELF.ControlSheet{PROP:Parent})
      create(SELF.ControlString,CREATE:string,SELF.ControlSheet{PROP:Parent})
   else   
      create(SELF.ControlImage,CREATE:image)
      create(SELF.ControlString,CREATE:string)
   .   
      
   SELF.SheetTabsHeight = 16   
      
   SELF.ControlSheet{PROP:Wizard}=1   
   SELF.ControlSheet{prop:height}=SELF.ControlSheet{prop:height} - SELF.SheetTabsHeight 
   SELF.ControlSheet{prop:yPos}=SELF.ControlSheet{prop:yPos} + SELF.SheetTabsHeight

   SELF.ControlImage{prop:xPos} = SELF.ControlSheet{prop:xPos} 
   SELF.ControlImage{prop:yPos} = SELF.ControlSheet{prop:yPos} - SELF.SheetTabsHeight + 1 
      
   SELF.CalcTabsWidth  !  image
   SELF.ControlImage{prop:height} = SELF.SheetTabsHeight
   0{prop:pixels}=1   
   SELF.ControlImage{prop:width} = SELF.SheetTabsWidth      
   0{prop:pixels}=0   
   unhide(SELF.ControlImage)       
   SELF.TabsLoad   ! 
      
   
   SELF.ToolbarClass &= (pClassToolbar)  !     
   SELF.GlobalClassAddr = pClassGlob   
   
!===================================================================================
!  
!
FsSheet.Kill PROCEDURE
      CODE
   if SELF.Active=0
      return
   end

   SELF.Active=0
   
   free(SELF.QueueTabs)
   dispose(SELF.QueueTabs)
   
   destroy(SELF.ControlString)
   destroy(SELF.ControlImage)
   
   SELF.ToolbarClass &= NULL

!===================================================================================
!
!  
!
FsSheet.Destruct PROCEDURE
   CODE
      SELF.Kill
      
!===================================================================================
!    
!
FsSheet.CalcTabsWidth PROCEDURE
loc:i   long
      CODE
      
   if SELF.Active=0
      return
   end
      
   0{prop:pixels}=1   
      
   SELF.SheetTabsWidth = 20
   SELF.ControlString{prop:fontName} = 'Arial'    
   SELF.ControlString{prop:fontSize} = 9         
   loop loc:i=FirstField() tO LastField()
      if loc:i{PROP:Parent} = SELF.ControlSheet
         if loc:i{PROP:HIDE}=1
            cycle
         .   
         SELF.ControlString{prop:text} = ''
         SELF.ControlString{prop:text} = clip(loc:i{PROP:TEXT}) & 'ff'
         SELF.SheetTabsWidth += SELF.ControlString{prop:width}
      .   
   .   
   SELF.ControlString{prop:text} = ''
   
   0{prop:pixels}=0   
   
!===================================================================================
!    
!
FsSheet.CalcTabWidth PROCEDURE (pContr)
loc:i   long
loc:w   long
      CODE
      
   if SELF.Active=0
      return(0)
   end
      
   0{prop:pixels}=1         
   SELF.ControlString{prop:fontName} = 'Arial'   !0{prop:fontName}   
   SELF.ControlString{prop:fontSize} = 9         !0{prop:fontSize} 

   SELF.ControlString{prop:text} = ''  
   SELF.ControlString{prop:text} = clip(pContr{PROP:TEXT})    
   loc:w=SELF.ControlString{prop:width}  
   0{prop:pixels}=0         

   return(loc:w) 
   
!===================================================================================
!    
!
FsSheet.ImageRefresh PROCEDURE
      CODE
      
   if SELF.Active=0
      return
   end

   SELF.ControlImage{prop:xPos} = SELF.ControlSheet{prop:xPos}
   SELF.ControlImage{prop:yPos} = SELF.ControlSheet{prop:yPos} - SELF.SheetTabsHeight
   SELF.CalcTabsWidth  !  image
   SELF.ControlImage{prop:height} = SELF.SheetTabsHeight
   0{prop:pixels}=1   
   SELF.ControlImage{prop:width} = SELF.SheetTabsWidth     
   0{prop:pixels}=0
     
!===================================================================================
!   
!
FsSheet.TabsLoad PROCEDURE
loc:i   long
loc:j   long
      CODE
      
   if SELF.Active=0
      return
   end
      
   loc:j=0   
   loop loc:i=FirstField() tO LastField()
      if loc:i{PROP:Parent} = SELF.ControlSheet
         loc:j+=1
         clear(SELF.QueueTabs)
         SELF.QueueTabs.NumTab=loc:i
         SELF.QueueTabs.ControlTab=SELF.ControlSheetTB+loc:j
         add(SELF.QueueTabs)
      .   
   .   
      
!===================================================================================
!    
!
FsSheet.TabsMakerInit PROCEDURE
loc:i   long
loc:w   long
      CODE
      
   if SELF.Active=0
      return
   end      
  
   SELF.ToolbarClass.SetAppName(command(0))
   SELF.ToolbarClass.SetPXP(SELF.GlobalClassAddr)
   SELF.ToolbarClass.InitControl(SELF.ControlImage, 1)
   if SELF.TabsStyle=2
      Self.ToolbarClass.SetStyle(PTB:STYLE_NATIVEXP)   
   .   
   SELF.ToolbarClass.SetFont('Arial', 9)
   SELF.ToolbarClass.SetAllowCustomize(False)
   SELF.ToolbarClass.AddBand(SELF.ControlSheetTB, PTB:BAND_Flat+PTB:BAND_NoCustomize, '', PTB:BT_Tabs)
   !Self.AddBand(TB1_Sheet1, PTB:BAND_Flat+PTB:BAND_NoCustomize, 'Sheet1', PTB:BT_Tabs)
   !Self.AddButton(TB1_Sheet1, ID1_Tab3, ' &', '', PTB:BTN_Tab+PTB:BTN_Checked)   
   loop loc:i=1 to records(SELF.QueueTabs)
      get(SELF.QueueTabs, loc:i)
      loc:w = SELF.CalcTabWidth(SELF.QueueTabs.NumTab)
      if loc:i=1
         SELF.ToolbarClass.AddButton(SELF.ControlSheetTB, SELF.QueueTabs.ControlTab, SELF.QueueTabs.NumTab{prop:text}, '', PTB:BTN_Tab+PTB:BTN_Checked)
         SELF.ToolbarClass.SetWidth(SELF.QueueTabs.ControlTab, loc:w)
      else   
         SELF.ToolbarClass.AddButton(SELF.ControlSheetTB, SELF.QueueTabs.ControlTab, SELF.QueueTabs.NumTab{prop:text}, '', PTB:BTN_Tab)
         SELF.ToolbarClass.SetWidth(SELF.QueueTabs.ControlTab, loc:w)         
      .   
   .   
      
   SELF.ToolbarClass.SetBackgroundColor(-1)  
   
      
!===================================================================================
!   
!
FsSheet.TabsTakeEvent PROCEDURE (LONG pEventID, LONG pControlID)
      CODE
      
   if SELF.Active=0
      return
   end      
      
   case pEventID
     of EVENT:Accepted
        clear(SELF.QueueTabs)
        SELF.QueueTabs.ControlTab=pControlID 
        get(SELF.QueueTabs, SELF.QueueTabs.ControlTab)
        if ~error()
            SELF.ControlSheet{PROP:ChoiceFeq} = SELF.QueueTabs.NumTab
            post(event:newselection,SELF.ControlSheet)            
        .    
    .      
      
!===================================================================================
!  
!
FsSheet.TabSelect PROCEDURE (LONG pContr)
      CODE
      
   if SELF.Active=0
      return
   end  
      
   clear(SELF.QueueTabs)
   SELF.QueueTabs.NumTab=pContr 
   get(SELF.QueueTabs, SELF.QueueTabs.NumTab)
   if ~error()      
      SELF.ToolbarClass.SetChecked(SELF.QueueTabs.ControlTab,1)
   .
      
!===================================================================================
!  
!
FsSheet.TabHide PROCEDURE (LONG pContr)
      CODE
      
   if SELF.Active=0
      return
   end  
      
   clear(SELF.QueueTabs)
   SELF.QueueTabs.NumTab=pContr 
   get(SELF.QueueTabs, SELF.QueueTabs.NumTab)
   if ~error()      
      SELF.ToolbarClass.SetVisible(SELF.QueueTabs.ControlTab,0)
   .
      
!===================================================================================
!  
!
FsSheet.TabUnHide PROCEDURE (LONG pContr)
      CODE
      
   if SELF.Active=0
      return
   end  
      
   clear(SELF.QueueTabs)
   SELF.QueueTabs.NumTab=pContr 
   get(SELF.QueueTabs, SELF.QueueTabs.NumTab)
   if ~error()      
      SELF.ToolbarClass.SetVisible(SELF.QueueTabs.ControlTab,1)
   .
      
!===================================================================================
!  
!
FsSheet.Refresh PROCEDURE (BYTE pCalc)
      CODE
      
   if SELF.Active=0
      return
   end  
      
   SELF.ToolbarClass.Refresh(pCalc)
      
!===================================================================================
!    
!
FsSheet.TabSetText PROCEDURE (LONG pContr, BYTE pReg)
loc:w  long
      CODE
      
   if SELF.Active=0
      return
   end  
      
   clear(SELF.QueueTabs)
   SELF.QueueTabs.NumTab=pContr 
   get(SELF.QueueTabs, SELF.QueueTabs.NumTab)
   if ~error() 
      SELF.ToolbarClass.SetText(SELF.QueueTabs.ControlTab,SELF.QueueTabs.NumTab{prop:text})
      loc:w = SELF.CalcTabWidth(SELF.QueueTabs.NumTab)
      SELF.ToolbarClass.SetWidth(SELF.QueueTabs.ControlTab, loc:w)      
      if pReg=1
        SELF.ImageRefresh
      .   
   .
      
!===================================================================================
!   NewSelection
!
FsSheet.EventNewSelection PROCEDURE 
      CODE
      
   if SELF.Active=0
      return
   end
      
   if field()=SELF.ControlSheet and event()=EVENT:NewSelection   
      SELF.TabSelect(SELF.ControlSheet{PROP:ChoiceFEQ})   
   .
      
!===================================================================================
!  
!
FsSheet.TabsSync PROCEDURE
loc:i   long
      CODE
      
   if SELF.Active=0
      return
   end     

   loop loc:i=1 to records(SELF.QueueTabs)
      get(SELF.QueueTabs,loc:i)
      if SELF.QueueTabs.NumTab{prop:hide}=1
         SELF.ToolbarClass.SetVisible(SELF.QueueTabs.ControlTab,0)
      else   
         SELF.ToolbarClass.SetVisible(SELF.QueueTabs.ControlTab,1)
      .   
   .       
   SELF.ImageRefresh
      

      
      
      
      
      
      
      
      

      